import { Directive } from "@surface/htmlx";
export default class RouterLinkDirective extends Directive {
    router;
    disposed = false;
    constructor(router, context) {
        super(context);
        this.router = router;
        if (context.element instanceof HTMLAnchorElement) {
            // eslint-disable-next-line no-script-url
            context.element.href = "javascript:void(0)";
        }
        context.element.addEventListener("click", this.onClick);
    }
    onClick = (event) => {
        if (event.ctrlKey) {
            window.open(this.value);
        }
        else {
            void this.router.push(this.value);
        }
    };
    dispose() {
        if (!this.disposed) {
            this.context.element.removeEventListener("click", this.onClick);
            super.dispose();
            this.disposed = true;
        }
    }
}
