import { Event } from "@surface/core";
import type NamedRoute from "./types/named-route.js";
import type Route from "./types/route.js";
import type WebRouterOptions from "./types/web-router-options.js";
export default class WebRouter {
    private readonly baseUrl;
    private readonly connectedElements;
    private readonly container;
    private readonly history;
    private readonly interceptors;
    private readonly root;
    private readonly router;
    private cache;
    private index;
    private context?;
    private scope;
    readonly routeChangeEvent: Event<{
        to: Route;
        from?: Route;
    }>;
    get route(): Route;
    constructor(options: WebRouterOptions);
    private connectToOutlet;
    private create;
    private createRoute;
    private disconnectElements;
    private disconnectFromOutlets;
    private resolveModule;
    private resolveComponent;
    private invokeMiddleware;
    private resolvePath;
    private pushOrReplace;
    back(): Promise<void>;
    forward(): Promise<void>;
    go(delta: number): Promise<void>;
    push(route: string | NamedRoute): Promise<void>;
    replace(route: string | NamedRoute): Promise<void>;
    pushCurrentLocation(): Promise<void>;
}
